//
// ShowAlonevOC̃\[Xt@CłB
//

//---------------------------------------------------------------------------
#include <stdio.h>
#include <windows.h>

// plugin include file --------------
#include "../Plugin.h"
#include "../MkaeApi.h"
#include "../GetMkaeList.h"

#ifdef _MSC_VER
#define snprintf _snprintf_s
#define strncpy(d,s,n) strcpy_s(d,n,s)
#endif

// global variables -----------------
HINSTANCE g_hinst;
HWND g_hwnd;
const char * g_classname  = "MadokaeDll_ShowAlone";
const char * g_pluginname = "ShowAlone";
char g_inifname[_MAX_PATH+2]; // `ۑpInit@C
MkaePluginMenu_t g_mymenu[] = {
        {1, 1, "L(&T)", "", "MyToggleEnable",  ""},
};

MkaeAPI g_MkaeApi;

struct Features_t {
        int is_enable;
        char enable_shortcut[MAX_SHORTCUT];
} g_fea;

// static function prototypes -------
int  DllProcessAttach(HINSTANCE hinstDLL, LPVOID lpvReserved);
void DllProcessDetach(LPVOID lpvReserved);

// callback -------------------------
extern "C" __declspec(dllexport) void __stdcall MyToggleEnable(const char *);
static void MyMinimizeWindow(const HWND i_hwnd);

//---------------------------------------------------------------------------
// DllMain
//---------------------------------------------------------------------------
#ifdef __BORLANDC__
#pragma argsused
#endif
BOOL WINAPI DllMain(HINSTANCE hinstDLL, DWORD fwdreason, LPVOID lpvReserved)
{
        switch (fwdreason) {
        case DLL_PROCESS_ATTACH: {
                if (0 != DllProcessAttach(hinstDLL, lpvReserved))
                        return 0; // error
                break;
        }
        case DLL_THREAD_ATTACH:
                break;
        case DLL_THREAD_DETACH:
                break;
        case DLL_PROCESS_DETACH:
                DllProcessDetach(lpvReserved);
                break;
        } // end of switch(fwdreason)
        return 1;
}
//---------------------------------------------------------------------------
 
int
DllProcessAttach(HINSTANCE hinstDLL, LPVOID lpvReserved)
{
        g_hinst = (HINSTANCE) hinstDLL;

        // APIL
        if (false == g_MkaeApi.IsEnable())
                return -1; // error

        // ւ̃o[W擾 (菈͖쐬)
        char version[80];
        g_MkaeApi.GetVersion(version, sizeof(version));

        // <vOC>.ini ̍쐬
        char mdlname[_MAX_PATH+2];
        GetModuleFileName((HINSTANCE)hinstDLL, mdlname, _MAX_PATH);
        LPSTR pext = strrchr(mdlname, '.');
        if (pext) *pext = '\0';
        snprintf(g_inifname, sizeof(g_inifname), "%s.ini", mdlname);

        return 0;
}

void
DllProcessDetach(LPVOID lpvReserved)
{
        // nothing to do
}

//---------------------------------------------------------------------------
// [Uj[ɐݒ肷R[obN֐
//---------------------------------------------------------------------------
// uLvIƂɌĂ΂֐
extern "C" __declspec(dllexport) void __stdcall
MyToggleEnable(const char * i_cmdargs)
{
        g_fea.is_enable = (g_fea.is_enable) ? 0 : 1;
        g_mymenu[0].checked = (g_fea.is_enable) ? true : false;
        g_MkaeApi.ReloadMenu(g_pluginname);
}

//---------------------------------------------------------------------------
// R[obN֐ (K{֐)
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) void __stdcall
Mkae_OnGetPluginInfo(MkaePluginInfo_t * o_info)
{
        memset(o_info, 0x0, sizeof(*o_info));
        strncpy(o_info->name, g_pluginname, (sizeof(o_info->name)-1));
}

//---------------------------------------------------------------------------
// R[obN֐ (Cӊ֐)
//---------------------------------------------------------------------------
extern "C" __declspec(dllexport) int __stdcall
Mkae_OnSetup(HWND i_hwnd_owner)
{
        g_fea.is_enable = ::GetPrivateProfileInt("General", "Enable", 1, g_inifname);
        g_mymenu[0].checked = (g_fea.is_enable) ? true : false; // j[ɔfĂ

        // V[gJbgL[
        ::GetPrivateProfileString(
                "ShortcutKey", "ToggleEnable", "",
                g_fea.enable_shortcut, sizeof(g_fea.enable_shortcut),
                g_inifname);

        return 0;
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnSetupRootMenu(unsigned int * o_count, MkaePluginMenu_t * o_menu)
{
        // KvȂ, Mkae_OnSetupSubMenu() ̗lɏ.
        // svȂ, ֐ƍ폜.
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnSetupSubMenu(unsigned int * o_count, MkaePluginMenu_t * o_menu)
{
        // vfԂ
        *o_count = (sizeof(g_mymenu) / sizeof(g_mymenu[0]));

        if (o_menu != NULL) {
                // o_menuNULLłȂΓe

                // shortcutkeyݒ
                snprintf(g_mymenu[0].shortcut, sizeof(g_mymenu[0].shortcut), 
                         "%s", g_fea.enable_shortcut);
                // j[copy
                memcpy(o_menu, &g_mymenu, sizeof(g_mymenu));
        }
}

extern "C" __declspec(dllexport) int __stdcall
Mkae_OnTeardown()
{
        // init@C֐ݒo
        char work[32];
        snprintf(work, sizeof(work), "%d", g_fea.is_enable);
        ::WritePrivateProfileString("General", "Enable", work, g_inifname);

        // V[gJbgL[
        ::WritePrivateProfileString(
                "ShortcutKey", "ToggleEnable", g_fea.enable_shortcut, g_inifname);
        return 0;
}

extern "C" __declspec(dllexport) void __stdcall
Mkae_OnWindowActive(const HWND i_hwnd)
{
        if (! g_fea.is_enable)
                return;

        GetMkaeList mkaelist;
        for (MkaeList_t * p = mkaelist.first(); p != NULL; p = mkaelist.next(p)) {
                if (p->hwnd_focused == i_hwnd) {
                        // ANeBu悤ƂĂEBhEnhȂskip
                        continue;
                }
                else if (p->is_custom) {
                        // vOC쐬̂Ȃskip
                        continue;
                }
                HWND prthwnd; 
                int isparent = 0;
                for (prthwnd = GetParent(i_hwnd); prthwnd != NULL; 
                     prthwnd = GetParent(prthwnd)) {
                        if (p->hwnd_focused == prthwnd) {
                                isparent = 1;
                                break;
                        }
                } // while
                if (isparent) {
                        // i_hwnd̐eEBhEȂŏȂ.skip
                        continue;
                }

                // ANeBuȂ̃EBhEnh,
                // ւ{̂쐬(^XNo[)GgȂ
                // ŏ.
                MyMinimizeWindow(p->hwnd);
        }
}


void MyMinimizeWindow(const HWND i_hwnd)
{
        if (!i_hwnd)
                return;

        // dialog͍ŏȂ悤ɂ
        char classname[255];
        ::GetClassName(i_hwnd, classname, sizeof(classname));
        int exstyle = ::GetWindowLong(i_hwnd, GWL_EXSTYLE);
        if ((exstyle & WS_EX_DLGMODALFRAME) &&
            0 == strcmp("#32770", classname)) {
                return;
        }

        // ŏ
        ::PostMessage(i_hwnd, WM_SYSCOMMAND, SC_MINIMIZE, 0);
}
